package org.mik;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;


@Entity(name=Student.TABLE_NAME)
public class Student implements Serializable {
	
	public final static String TABLE_NAME = "Student";
	public final static String ID = "id"; 
	public final static String NAME="name"; 
	public final static String EHA="eha"; 
	public final static String AVERAGE="average"; 
	
	@Id
	@Column(name=ID)
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private int id;
	
	@Column(name=NAME, nullable=false)
	private String name;
	
	@Column(name=EHA, nullable=false, unique=true)
	private String eha;
	
	@Column(name=AVERAGE)	
	private double average;

	/**
	 * 
	 */
	public Student() {

	}

	/**
	 * @param name
	 * @param eha
	 * @param average
	 */
	public Student(String name, String eha, double average) {
		this.name = name;
		this.eha = eha;
		this.average = average;

	}

	/**
	 * @return the id
	 */
	public int getId() {
		return this.id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return this.name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the eha
	 */
	public String getEha() {
		return this.eha;
	}

	/**
	 * @param eha the eha to set
	 */
	public void setEha(String eha) {
		this.eha = eha;
	}

	/**
	 * @return the average
	 */
	public double getAverage() {
		return this.average;
	}

	/**
	 * @param average the average to set
	 */
	public void setAverage(double average) {
		this.average = average;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Student [id=" + this.id + ", name=" + this.name + ", eha=" + this.eha
				+ ", average=" + this.average + "]";
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((eha == null) ? 0 : eha.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Student other = (Student) obj;
		if (eha == null) {
			if (other.eha != null)
				return false;
		} else if (!eha.equals(other.eha))
			return false;
		return true;
	}
	
}
